<script>
  export let task // required

  import { stores } from "@sapper/app"
  import Alert from "sveltestrap/src/Alert.svelte"
  import Progress from "sveltestrap/src/Progress.svelte"
  import * as model from "../model.js"

  const { session } = stores()
  const { config } = $session

  $: isGenerationInProgress = model.isGenerationInProgress(task)
  $: taskDuration = model.taskDuration(task)
  $: color = isGenerationInProgress
    ? "primary"
    : task.state === "SUCCESS"
    ? "success"
    : "danger"
  $: flowerHref = config.flowerUrl
    ? `${config.flowerUrl}/task/${task.id}`
    : null
</script>

<Alert {color}>
  {#if isGenerationInProgress}
    <p>
      {#if task.state === "PENDING"}
        La génération du PDF est en attente de prise en compte
      {:else}
        La génération du PDF est en cours depuis le {task.date_start.format("L à LT")}
        ({taskDuration.humanize()})...
      {/if}
    </p>
    <Progress animated color="info" value={100} />
  {:else if task.state === "FAILURE"}
    La dernière génération du PDF a échoué le {task.date_done.format("L à LT")}
    au bout de {taskDuration.humanize()}.
  {:else if task.state === "REVOKED"}
    La dernière génération du PDF a été annulée le {task.date_done.format("L à LT")}
    au bout de {taskDuration.humanize()}.
  {:else if task.state === "SUCCESS"}
    Le PDF a été généré avec succès le {task.date_done.format("L à LT")} au bout
    de {taskDuration.humanize()}.
  {:else}
    La dernière génération du PDF a terminé dans un état inconnu "{task.state}"
    le {task.date_done.format("L à LT")} au bout de {taskDuration.humanize()}.
  {/if}
  <!--
  {#if flowerHref}
    <div class="d-flex justify-content-end">
      <a
        href={flowerHref}
        class="small"
        title="Voir les informations sur la tâche dans le tableau de bord"
        rel="external"
        target="_blank">
        détails
      </a>
    </div>
  {/if}
  -->
</Alert>
